// mount a photovoltaic charger for some lights on a pole
include <BOSL2/std.scad>
include <BOSL2/hinges.scad>

$fn=32;$fa=5;$fs=0.5;

$bolt_d = 6;
$lightside_d = 14;
$len = 15;
$bar_d = 38;
$clamp_t = 3;

diff()
tube(id=$bar_d, wall = $clamp_t, h=$len, anchor=TOP)  {
  attach(RIGHT, LEFT, overlap=$clamp_t/2) 
    render() zrot(90) cube([$len, $len, 14]) 
    {
      // tag("debug") anchor_arrow(20);
      screw_hole("M5",length=12, head="socket",counterbore=6,anchor=CENTER)
        position(BOT) nut_trap_inline(l=6,anchor=BOT);
      tag("remove")
        right(1)
        position(RIGHT) cube([20+$clamp_t, $len + 11, 2], anchor = RIGHT);
    }
  // some implicit times-three multipliers in here because the knuckle
  // hinge has invisible outer hinge friends
  attach(FRONT, BOTTOM, overlap=$clamp_t) 
    render() knuckle_hinge(length=$len*3, offset=$len*2,
                           segs=3, inner=true,
                           pin_diam=$bolt_d, knuckle_diam=$lightside_d,
                           arm_height=0, fill=false,
                           arm_angle=90,
                           anchor=BOTTOM+LEFT,
                           spin=90);
}
